<script>
  // Import modules
  import { scaleLinear, scaleRadial } from "d3-scale";
  import { extent } from "d3-array";
  import { radialArea } from "d3-shape";

  // Export variables
  export let data;
  export let city;

  // Define circle radius
  let radius = 70;

  // Margins
  const width = 600;
  const height = 250;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };

  // Filter cities
  data = data.filter(d => d.city == city);

  // Define the scales
  const xScale = scaleLinear().range([0,2*Math.PI]).domain(extent(data, d => d.day_of_year))
  const yScaleHot = scaleRadial().range([0,radius-5]).domain(extent(data, d => d.heating))
  const yScaleCool = scaleRadial().range([0,radius-5]).domain(extent(data, d => d.cooling))

  // Define the areas
  const HotArea = radialArea().angle(d => xScale(d.day_of_year)).innerRadius(0).outerRadius(d => yScaleHot(d.heating))
  const CoolArea = radialArea().angle(d => xScale(d.day_of_year)).innerRadius(0).outerRadius(d => yScaleCool(d.cooling))

</script>
<svg viewBox="0 0 {width/3} {height}" style="max-width: {width/3}px">
  <g transform="translate({margin.left}, {margin.top})">
      <g transform="translate(0,15)">
          <text class="sub_plot_title" text-anchor="middle" x="50%">{city}</text>
      </g>
      <g transform="translate({width/6},115)">
          <circle cx=0 cy=0 r={radius}/> 
          <path class="heating" d={HotArea(data)}/>
          <path class="cooling" d={CoolArea(data)}/>
          <line class="cross" x1=0 y1={-radius} x2=0 y2={radius}/>
          <line class="cross" x1={-radius} y1=0 x2={radius} y2=0/>
          <text class="clock_numbers" transform="translate({-5},{-radius - 10})">0</text>
          <text class="clock_numbers" transform="translate({-5},{radius + 20})">6</text>
          <text class="clock_numbers" transform="translate({radius+10},5)">3</text>
          <text class="clock_numbers" transform="translate({-radius-20},5)">9</text>
      </g>
      {#if city == "Baltimore"}
      <g transform="translate(35,45)">
        <text text-anchor="middle" fill="red">Heating</text>
        <line class="heating" x1=5 y1=5 x2=50 y2=13/>
      </g>
      <g transform="translate(150,210)">
        <text text-anchor="middle" fill="blue">Cooling</text>
        <line class="cooling" x1=-10 y1=-10 x2=-30 y2=-55/>
      </g>
      <g transform="translate(165,60)">
        <text text-anchor="middle" font-size="13" fill="black">Month</text>
        <path stroke="black" fill="white" d="M -5,5 Q 8,10 13,27" />
        <path stroke="black" fill="white" d="M 13,27 15,20" />
        <path stroke="black" fill="white" d="M 13,27 8,24" />
      </g>
      {/if}
  </g>
</svg>

<style>
  circle{
    stroke: black;
    stroke-width: .7;
    fill: none;
  }

  text.sub_plot_title{
    font-size: 17px;
  }

  text.clock_numbers{
      font-size: 15px;
  }

  line{
    stroke: black;
    stroke-width: 2;
    stroke-opacity: 0.4;
  }

  line.cross{
    stroke-width: 1px;
  }

  .heating{
    fill: red;
    fill-opacity: 0.4;
    stroke: red;
    stroke-opacity: 1;
    stroke-width: 0.5;
  }

  .cooling{
    fill: blue;
    fill-opacity: 0.5;
    stroke: blue;
    stroke-opacity: 1;
    stroke-width: 0.5;
  }
</style>
